var N = null;var searchIndex = {};
searchIndex["bitflags"]={"doc":"A typesafe bitmask flag generator useful for sets of C-style bitmask flags. It can be used for creating typesafe wrappers around C APIs.","items":[[14,"bitflags","bitflags","The macro used to generate the flag structure.",N,N]],"paths":[]};
searchIndex["gokien"]={"doc":"","items":[[0,"charset","gokien","Hard-coded charset tables for output.",N,N],[5,"get_charset_table","gokien::charset","",N,N],[5,"get_charset_mapping","","",N,[[["vncharset"]],["hashmap"]]],[17,"VN_UTF8_TABLE","","A map table, encoded in UTF-8 charset, of all character in Vietnamese.",N,N],[0,"engine","gokien","",N,N],[3,"GkOptions","gokien::engine","",N,N],[3,"GkEngine","","",N,N],[4,"VnInputMethod","","An input method for GoKien Engine",N,N],[13,"Telex","","",0,N],[13,"Vni","","",0,N],[4,"VnCharset","","Only support UTF-8 for now",N,N],[13,"Utf8","","",1,N],[4,"GkError","","",N,N],[13,"NoVietnamese","","",2,N],[18,"FREE_MARKING","","To type mark at the end of the word. TELEX user should disable this option, VNI user should enable this.",3,N],[18,"MODERN_STYLE","","Use \"hoá\" instead of \"hóa\".",3,N],[18,"MACRO_ENABLE","","",3,N],[18,"USE_CLIPBOARD","","",3,N],[18,"ALWAYS_MACRO","","",3,N],[18,"STRICT_SPELLING","","",3,N],[18,"SPELL_CHECK_ENABLE","","",3,N],[18,"RESTORE_NON_VN","","",3,N],[11,"empty","","Returns an empty set of flags.",3,[[],["gkoptions"]]],[11,"all","","Returns the set containing all flags.",3,[[],["gkoptions"]]],[11,"bits","","Returns the raw value of the flags currently stored.",3,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",3,[[["u8"]],["option",["gkoptions"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",3,[[["u8"]],["gkoptions"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",3,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",3,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",3,[[["self"],["gkoptions"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",3,[[["self"],["gkoptions"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",3,[[["self"],["gkoptions"]]]],[11,"remove","","Removes the specified flags in-place.",3,[[["self"],["gkoptions"]]]],[11,"toggle","","Toggles the specified flags in-place.",3,[[["self"],["gkoptions"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",3,[[["self"],["gkoptions"],["bool"]]]],[11,"new","","Creates a new empty `GkEngine`.",4,[[],["self"]]],[11,"set_input_method","","",4,[[["self"],["vninputmethod"]],["self"]]],[11,"trans","","Change output charset: UTF-8, VIQR. Translate directly a byte slice to Vietnamese String. Do NOT reserve previous state.",4,N],[11,"push_str","","",4,[[["self"],["str"]]]],[0,"syntax","gokien","This module contains some Enums of Vietnamese characters and defines rules to interact with.",N,N],[3,"VnSyllable","gokien::syntax","Each Vietnamese monosyllabic word can be decomposed at most into 4 parts, which are:",N,N],[4,"LexicalChar","","This includes English lexical character plus extended Vietnamese character.",N,N],[13,"A","","",5,N],[13,"A1","","",5,N],[13,"A2","","",5,N],[13,"A3","","",5,N],[13,"A4","","",5,N],[13,"A5","","",5,N],[13,"A6","","",5,N],[13,"A61","","",5,N],[13,"A62","","",5,N],[13,"A63","","",5,N],[13,"A64","","",5,N],[13,"A65","","",5,N],[13,"A8","","",5,N],[13,"A81","","",5,N],[13,"A82","","",5,N],[13,"A83","","",5,N],[13,"A84","","",5,N],[13,"A85","","",5,N],[13,"B","","",5,N],[13,"C","","",5,N],[13,"D","","",5,N],[13,"D9","","",5,N],[13,"E","","",5,N],[13,"E1","","",5,N],[13,"E2","","",5,N],[13,"E3","","",5,N],[13,"E4","","",5,N],[13,"E5","","",5,N],[13,"E6","","",5,N],[13,"E61","","",5,N],[13,"E62","","",5,N],[13,"E63","","",5,N],[13,"E64","","",5,N],[13,"E65","","",5,N],[13,"F","","",5,N],[13,"G","","",5,N],[13,"H","","",5,N],[13,"I","","",5,N],[13,"I1","","",5,N],[13,"I2","","",5,N],[13,"I3","","",5,N],[13,"I4","","",5,N],[13,"I5","","",5,N],[13,"J","","",5,N],[13,"K","","",5,N],[13,"L","","",5,N],[13,"M","","",5,N],[13,"N","","",5,N],[13,"O","","",5,N],[13,"O1","","",5,N],[13,"O2","","",5,N],[13,"O3","","",5,N],[13,"O4","","",5,N],[13,"O5","","",5,N],[13,"O6","","",5,N],[13,"O61","","",5,N],[13,"O62","","",5,N],[13,"O63","","",5,N],[13,"O64","","",5,N],[13,"O65","","",5,N],[13,"O7","","",5,N],[13,"O71","","",5,N],[13,"O72","","",5,N],[13,"O73","","",5,N],[13,"O74","","",5,N],[13,"O75","","",5,N],[13,"P","","",5,N],[13,"Q","","",5,N],[13,"R","","",5,N],[13,"S","","",5,N],[13,"T","","",5,N],[13,"U","","",5,N],[13,"U1","","",5,N],[13,"U2","","",5,N],[13,"U3","","",5,N],[13,"U4","","",5,N],[13,"U5","","",5,N],[13,"U7","","",5,N],[13,"U71","","",5,N],[13,"U72","","",5,N],[13,"U73","","",5,N],[13,"U74","","",5,N],[13,"U75","","",5,N],[13,"V","","",5,N],[13,"W","","",5,N],[13,"X","","",5,N],[13,"Y","","",5,N],[13,"Y1","","",5,N],[13,"Y2","","",5,N],[13,"Y3","","",5,N],[13,"Y4","","",5,N],[13,"Y5","","",5,N],[13,"Z","","",5,N],[4,"LexicalKind","","",N,N],[13,"Vowel","","",6,N],[13,"Consonant","","",6,N],[4,"Vowel","","Lists all vowels (nguyên âm) in Vietnamese.",N,N],[13,"A","","",7,N],[13,"A6","","",7,N],[13,"A8","","",7,N],[13,"E","","",7,N],[13,"E6","","",7,N],[13,"I","","",7,N],[13,"O","","",7,N],[13,"O6","","",7,N],[13,"O7","","",7,N],[13,"U","","",7,N],[13,"U7","","",7,N],[13,"Y","","",7,N],[13,"Ai","","",7,N],[13,"Ao","","",7,N],[13,"Au","","",7,N],[13,"A6u","","",7,N],[13,"Ay","","",7,N],[13,"A6y","","",7,N],[13,"Eo","","",7,N],[13,"E6u","","",7,N],[13,"Ia","","",7,N],[13,"Ie6","","",7,N],[13,"Ye6","","",7,N],[13,"Iu","","",7,N],[13,"Oa","","",7,N],[13,"Oa8","","",7,N],[13,"Oe","","",7,N],[13,"Oi","","",7,N],[13,"O6i","","",7,N],[13,"O7i","","",7,N],[13,"Oo","","",7,N],[13,"O6o6","","",7,N],[13,"Ua","","",7,N],[13,"Ua8","","",7,N],[13,"Ua6","","",7,N],[13,"U7a","","",7,N],[13,"Ue6","","",7,N],[13,"Ui","","",7,N],[13,"U7i","","",7,N],[13,"Uo","","",7,N],[13,"Uo6","","",7,N],[13,"Uo7","","",7,N],[13,"U7o7","","",7,N],[13,"U7u","","",7,N],[13,"Uy","","",7,N],[13,"Ie6u","","",7,N],[13,"Ye6u","","",7,N],[13,"Oai","","",7,N],[13,"Oao","","",7,N],[13,"Oay","","",7,N],[13,"Oeo","","",7,N],[13,"Uao","","",7,N],[13,"Ua6y","","",7,N],[13,"Uo6i","","",7,N],[13,"U7o7i","","",7,N],[13,"U7o7u","","",7,N],[13,"Uya","","",7,N],[13,"Uye6","","",7,N],[13,"Uyu","","",7,N],[4,"Consonant","","List all consonants (phụ âm) in Vietnamese.",N,N],[13,"B","","",8,N],[13,"C","","",8,N],[13,"Ch","","",8,N],[13,"D","","",8,N],[13,"D9","","",8,N],[13,"G","","",8,N],[13,"Gh","","",8,N],[13,"Gi","","",8,N],[13,"H","","",8,N],[13,"K","","",8,N],[13,"Kh","","",8,N],[13,"L","","",8,N],[13,"M","","",8,N],[13,"N","","",8,N],[13,"Ng","","",8,N],[13,"Ngh","","",8,N],[13,"Nh","","",8,N],[13,"P","","",8,N],[13,"Ph","","",8,N],[13,"Q","","",8,N],[13,"Qu","","",8,N],[13,"R","","",8,N],[13,"S","","",8,N],[13,"T","","",8,N],[13,"Th","","",8,N],[13,"Tr","","",8,N],[13,"V","","",8,N],[13,"X","","",8,N],[5,"get_without_tone_idx","","",N,[[["u8"]],["u8"]]],[17,"LEXICAL_TOTAL","","A number represents total variants of LexicalChar enum.",N,N],[17,"VN_ROOT_CHARS","","This map table use to calculate non-marked and non-toned offset in [`LexicalChar`] enum.",N,N],[17,"VN_NON_TONED_CHARS","","This map table use to calculate non-toned offset in [`LexicalChar`] enum.",N,N],[17,"VN_LEXICAL_KIND_MAP","","",N,N],[8,"VowelKindExt","","This trait implements a few method to check if object is an elemental vowel, a diphthong or a triphthong.",N,N],[10,"is_elemental","","Check if vowel is elemental (or primary, basic). Also called monophthongs.",9,[[["self"]],["bool"]]],[10,"is_dipthong","","Check if vowel is a diphthong.",9,[[["self"]],["bool"]]],[10,"is_triphthong","","Check if vowel is a triphthong..",9,[[["self"]],["bool"]]],[11,"must_or_with_vowel","","Check if vowel must be followed by another vowel or a consonant.",7,[[["self"]],["bool"]]],[11,"must_with_final_consonant","","Check if vowel must be only followed by a consonant.",7,[[["self"]],["bool"]]],[11,"must_without_final_consonant","","Check if vowel is without final consonant.",7,[[["self"]],["bool"]]],[11,"is_free_diphthong","","Check if diphthong is free. Those diphthongs are: oa, oe, uê, uy.",7,[[["self"]],["bool"]]],[11,"is_initial","","Check if consonant is a initial consonant.",8,[[["self"]],["bool"]]],[11,"is_final","","Check if consonant is a final consonant.",8,[[["self"]],["bool"]]],[0,"tone","gokien","",N,N],[4,"Tone","gokien::tone","Tone (thanh điệu), which also called \"accent\", lists all possible tones in Vietnamese.",N,N],[13,"None","","",10,N],[13,"Grave","","",10,N],[13,"Acute","","",10,N],[13,"HookAbove","","",10,N],[13,"Tilde","","",10,N],[13,"DotBelow","","",10,N],[11,"get_tone","","Get tone from a char `ch`.",10,[[["char"],["vncharset"]],["tone"]]],[11,"add_tone","","Add a tone `tone` to char `ch`.",10,[[["char"],["tone"],["vncharset"]],["char"]]],[11,"clear_tone","","Clear the tone in `ch`. Return the result and the old tone.",10,N],[0,"prelude","gokien","A convenience module appropriate for glob imports (`use gokien::prelude::*;`).",N,N],[11,"into","gokien::engine","",3,[[["self"]],["u"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"into","gokien::syntax","",11,[[["self"]],["u"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"into","gokien::tone","",10,[[["self"]],["u"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"is_elemental","gokien::syntax","Check if vowel is elemental (or primary, basic).",7,[[["self"]],["bool"]]],[11,"is_dipthong","","Check if vowel is a diphthong.",7,[[["self"]],["bool"]]],[11,"is_triphthong","","Check if vowel is a triphthong.",7,[[["self"]],["bool"]]],[11,"partial_cmp","gokien::engine","",3,[[["self"],["gkoptions"]],["option",["ordering"]]]],[11,"lt","","",3,[[["self"],["gkoptions"]],["bool"]]],[11,"le","","",3,[[["self"],["gkoptions"]],["bool"]]],[11,"gt","","",3,[[["self"],["gkoptions"]],["bool"]]],[11,"ge","","",3,[[["self"],["gkoptions"]],["bool"]]],[11,"default","","",0,[[],["self"]]],[11,"default","","",1,[[],["self"]]],[11,"default","","",3,[[],["self"]]],[11,"default","","",4,[[],["gkengine"]]],[11,"cmp","","",3,[[["self"],["gkoptions"]],["ordering"]]],[11,"eq","","",3,[[["self"],["gkoptions"]],["bool"]]],[11,"ne","","",3,[[["self"],["gkoptions"]],["bool"]]],[11,"eq","gokien::tone","",10,[[["self"],["tone"]],["bool"]]],[11,"from","","",10,[[["u8"]],["self"]]],[11,"clone","gokien::engine","",1,[[["self"]],["vncharset"]]],[11,"clone","","",3,[[["self"]],["gkoptions"]]],[11,"clone","gokien::syntax","",5,[[["self"]],["lexicalchar"]]],[11,"extend","gokien::engine","",3,[[["self"],["t"]]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"fmt","gokien::syntax","",5,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"fmt","gokien::tone","",10,[[["self"],["formatter"]],["result"]]],[11,"fmt","gokien::engine","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"hash","","",3,N],[11,"sub","","Returns the set difference of the two sets of flags.",3,[[["self"],["gkoptions"]],["gkoptions"]]],[11,"sub_assign","","Disables all flags enabled in the set.",3,[[["self"],["gkoptions"]]]],[11,"not","","Returns the complement of this set of flags.",3,[[["self"]],["gkoptions"]]],[11,"bitand","","Returns the intersection between the two sets of flags.",3,[[["self"],["gkoptions"]],["gkoptions"]]],[11,"bitor","","Returns the union of the two sets of flags.",3,[[["self"],["gkoptions"]],["gkoptions"]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",3,[[["self"],["gkoptions"]],["gkoptions"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",3,[[["self"],["gkoptions"]]]],[11,"bitor_assign","","Adds the set of flags.",3,[[["self"],["gkoptions"]]]],[11,"bitxor_assign","","Toggles the set of flags.",3,[[["self"],["gkoptions"]]]],[11,"from_iter","","",3,[[["t"]],["gkoptions"]]]],"paths":[[4,"VnInputMethod"],[4,"VnCharset"],[4,"GkError"],[3,"GkOptions"],[3,"GkEngine"],[4,"LexicalChar"],[4,"LexicalKind"],[4,"Vowel"],[4,"Consonant"],[8,"VowelKindExt"],[4,"Tone"],[3,"VnSyllable"]]};
searchIndex["lazy_static"]={"doc":"A macro for declaring lazily evaluated statics.","items":[[5,"initialize","lazy_static","Takes a shared reference to a lazy static and initializes it if it has not been already.",N,[[["t"]]]],[8,"LazyStatic","","Support trait for enabling a few common operation on lazy static values.",N,N],[14,"lazy_static","","",N,N]],"paths":[]};
initSearch(searchIndex);
